//CatalogueImages_210f.js
// 07.01.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Un catalogue avec les images du dossier slctionn

//Un JavaScript pour InDesign CS2, bas sur le script "ImageCatalog.jsx" d'Adobe
//Traduit, optimis et complt par Hans Haesler <hsa@ringier.ch>

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// 'sufString': une variable globale, contenant une liste de suffixes
sufString = "|.psd|.tif|.ai|.jpg|.pdf|.eps|.tiff|.png|.gif|";
// afficher le dialogue pour la slection du dossier
var selFolder = Folder.selectDialog("Slctionner le dossier contenant les images  importer.");
// dfinir le chemin au dossier source
if (selFolder != null) {
	// prparer quatre listes
	var mainList = new Array();
	var foldList = new Array();
	var mainFileList = new Array();
	var subFileList  = new Array();
	var nMain = nSub = 0;

	// aller chercher les chemins des fichiers du dossier principal et des sous-dossiers
	var fileFold = getMainFiles(selFolder, mainList, foldList);
	
	mainFiles = fileFold[0];
	if (mainFiles.length > 0) {
		// envoyer au filtrage
		mainFileList = fileFilter1(mainFiles);
		nMain = mainFileList.length;
	}
	foldList  = fileFold[1];
	var nFold = foldList.length;
	if (nFold > 0) {
		var subsList = new Array();
		for (n=0; n<nFold; n++) {
			var tmpList = new Array();
			// aller chercher les chemins des fichiers des sous-dossiers
			subsList = subsList.concat(getSubFiles(foldList[n], tmpList));
		}
		// envoyer au filtrage
		subFileList = fileFilter1(subsList);
		nSub = subFileList.length;
	}
	
	// le nombre des fichiers (le total est celui du dossier principal et des sous-dossiers)
	var nAll = nMain + nSub;
	
	if (nAll == 0) {
		alert ("Le dossier slctionn ne contient pas de fichiers d'images importables.", "Stop", true);
		exit();
	}
	
	// appeler la fonction qui lit les prfrences mmorises
	var defStr = getPrefs();
	// extraire les valeurs (si le fichier des prfrences existe)
	if (defStr != "") {
		var catDef = defStr.split("\n");
		fMan = catDef[0];
		if (fMan == "false") {fMan = false;}
		else {fMan = true;}
		fSub = catDef[1];
		if (fSub == "false") {fSub = false;}
		else {fSub = true;}
		aSiz = catDef[2];
		if (aSiz == "false") {aSiz = false;}
		else {aSiz = true;}
		bSiz = catDef[3];
		if (bSiz == "false") {bSiz = false;}
		else {bSiz = true;}
		cSiz = catDef[4];
		if (cSiz == "false") {cSiz = false;}
		else {cSiz = true;}
		dSiz = catDef[5];
		if (dSiz == "false") {dSiz = false;}
		else {dSiz = true;}
		eSiz = catDef[6];
		if (eSiz == "false") {eSiz = false;}
		else {eSiz = true;}
		pSiz = catDef[7];
		mVal = catDef[8];
		rVal = catDef[9]*1;
		cVal = catDef[10]*1;
		vOff = catDef[11]*1;
		hOff = catDef[12]*1;
		aDir = catDef[13];
		if (aDir == "false") {aDir = false;}
		else {aDir = true;}
		bDir = catDef[14];
		if (bDir == "false") {bDir = false;}
		else {bDir = true;}
		aSor = catDef[15];
		if (aSor == "false") {aSor = false;}
		else {aSor = true;}
		bSor = catDef[16];
		if (bSor == "false") {bSor = false;}
		else {bSor = true;}
		cSor = catDef[17];
		if (cSor == "false") {cSor = false;}
		else {cSor = true;}
		dSor = catDef[18];
		if (dSor == "false") {dSor = false;}
		else {dSor = true;}
		eSor = catDef[19];
		if (eSor == "false") {eSor = false;}
		else {eSor = true;}
		fPrp = catDef[20];
		if (fPrp == "false") {fPrp = false;}
		else {fPrp = true;}
		sPct = catDef[21];
		if (sPct == "false") {sPct = false;}
		else {sPct = true;}
		hPct = catDef[22];
		if (hPct == "false") {hPct = false;}
		else {hPct = true;}
		fFra = catDef[23];
		if (fFra == "false") {fFra = false;}
		else {fFra = true;}
		nNam = catDef[24];
		if (nNam == "false") {nNam = false;}
		else {nNam = true;}
		fNam = catDef[25];
		if (fNam == "false") {fNam = false;}
		else {fNam = true;}
		pNam = catDef[26];
		if (pNam == "false") {pNam = false;}
		else {pNam = true;}
		sInf 
		= catDef[27];
		if (sInf == "false") {sInf = false;}
		else {sInf = true;}
		pInf = catDef[28];
		if (pInf == "false") {pInf = false;}
		else {pInf = true;}
		tSiz = catDef[29]*1;
		jLft = catDef[30];
		if (jLft == "false") {jLft = false;}
		else {jLft = true;}
		jCnt = catDef[31];
		if (jCnt == "false") {jCnt = false;}
		else {jCnt = true;}
		jRgt = catDef[32];
		if (jRgt == "false") {jRgt = false;}
		else {jRgt = true;}
		rEmp = catDef[33];
		if (rEmp == "false") {rEmp = false;}
		else {rEmp = true;}
	}
	else { // quand le fichier des prfrences est introuvable
		fMan = false;
		fSub = true;
		aSiz = false;
		bSiz = false;
		cSiz = false;
		dSiz = true;
		eSiz = false;
		pSiz = "240 180";
		mVal = "12 8 12 12";
		rVal = 3;
		cVal = 3;
		vOff = 18;
		hOff = 4;
		aDir = true;
		bDir = false;
		aSor = true;
		bSor = false;
		cSor = false;
		dSor = true;
		eSor = false;
		fPrp = false;
		sPct = true;
		hPct = false;
		fFra = false;
		nNam = false;
		fNam = true;
		pNam = false;
		sInf = false;
		pInf = false;
		tSiz = 10;
		jLft = true;
		jCnt = false;
		jRgt = false;
		rEmp = true;
	}
	// appeler la fonction qui prpare le dialogue
	askUser(nMain, nSub, nAll);

	// dresser la liste des chemins des fichiers
	if (fMan == true) {
		if (nMain > 0) {
			tmpList = mainFileList;
		}
		else {
			alert ("Le dossier principal ne contient pas de fichiers image.", "Stop");
			exit();
		}
	}
	else {
		if (nMain > 0 && nSub > 0) {
			tmpList = mainFileList.concat(subFileList);
		}
		else if (nMain > 0 && nSub == 0) {
			tmpList = mainFileList;
		}
		else if (nMain == 0 && nSub > 0) {
			tmpList = subFileList;
		}
	}
	if (aSor) { // le tri alphabtique
		if (fMan == true) { // seulement le dossier principal
			if (dSor) { // ascendant
				defList = tmpList.sort();
			}
			else if (eSor) { // descendant
				defList = tmpList.sort();
				defList.reverse();
			}
		}
		else { // avec les sous-dossiers
			var namesArr = getNames(tmpList);
			// trier la liste
			namesArr.sort(function(a, b) {
				if (dSor) { // ascendant
					return a[1] > b[1];
				}
				else if (eSor) { // descendant
					return a[1] < b[1];
				}
			});
			// appliquer  la liste dfinitive
			defList = namesArr;
		}
	}
	else if (bSor) { // trier numriquement
		// le nombre de noms
		var nNames = tmpList.length;
		// l'objet RegExp des chiffres
		var num = new RegExp("[0-9]+");
		// tester si le pemier nom contient un chiffre
		var pos = tmpList[0].name.search(num);
		if (pos == -1) {
			alert ("Le premier nom ne contient pas de chiffre.", "Stop");
			exit();
		}
		var numbersArr = getNumbers(tmpList, nNames, num);
		// trier la liste
		numbersArr.sort(function(a, b) {
			if (dSor) { // ascendant
				return a[1] - b[1];
			}
			else if (eSor) { // descendant
				return b[1] - a[1];
			}
		});
		// appliquer  la liste dfinitive
		defList = numbersArr;
	}
	else if (cSor) { // la date de cration
		var datesArr = getDates(tmpList);
		// trier la liste
		datesArr.sort(function(a, b) {
			if (dSor) { // ascendant
				return a[1] - b[1];
			}
			else if (eSor) { // descendant
				return b[1] - a[1];
			}
		});
		// appliquer  la liste dfinitive
		defList = datesArr;
	}

	// appeler la fonction pour la cration du catalogues des images
	makeImageCatalog();
}

// la fonction qui dresse la liste des images (et tient compte des sous-dossiers)
function getMainFiles(selFolder, mainList, foldList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			foldList.push(f[i]);
		}
		else {
			mainList.push(f[i]);
		}
	}
	return [mainList, foldList];
}

// la fonction qui dresse la liste des images des sous-dossiers
function getSubFiles(subFolder, tmpList) {
	var f = Folder(subFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			getSubFiles(f[i], tmpList);
		}
		else {
			tmpList.push(f[i]);
		}
	}
	return tmpList;
}

// la premire partie du filtre des fichiers
function fileFilter1(subFiles){
	var curFileList = new Array();
	for (var i=0; i<subFiles.length; i++) {
		curFile = subFiles[i];
		if (fileFilter2(curFile)) {
			curFileList.push(curFile);
		}
	}
	return curFileList;
}

// la deuxime partie du filtre des fichiers (version Mac OS) 
// ncessaire parce qu'il y a souvent des fichiers sans suffixe
function fileFilter2(curFile){
	var curFileType = curFile.type;
	switch (curFileType){
		case "JPEG":
		case "EPSF":
		case "PICT":
		case "TIFF":
		case "8BPS":
		case "GIFf":
		case "PDF ":
			return true;
			break;
		default:
		var curName = curFile.name.toLowerCase();
		try {
			var curItems = curName.split(".");
			var curSuf = "|." + curItems[(curItems.length)-1] + "|";
			if (sufString.indexOf(curSuf) != -1) {
				return true;
			}
			else {
				return false;
			}
		}
		catch (e) {
			return false;
		}
	}
}

// la fonction qui prpare les informations
function getPrefs() {
	var defStr = "";
	// lire le fichier contenant les rglages mmoriss
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/cat210.txt");
	}
	else {
		var f = new File("~/Library/Preferences/cat210.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// la fonction qui prpare le dialogue, l'affiche et convertit les valeurs
function askUser(nMain, nSub, nAll) {
	// effacer des dialogues rests ouverts
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var labelWidth  = 135;
	var labelWidth2 =  94;
	var textWidth   = 206;
	var aDialog = app.dialogs.add({name:"Catalogue d'images"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"" + nAll + " fichiers  (principal = " + nMain + " / sous-dossiers = " + nSub + ")"});
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Choix du dossier", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var folButtons = radiobuttonGroups.add();
						with (folButtons) {
							radiobuttonControls.add({staticLabel:"dossier principal seul", minWidth:textWidth, checkedState:fMan});
							radiobuttonControls.add({staticLabel:"y compris les sous-dossiers", minWidth:textWidth, checkedState:fSub});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Format de page", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var sizeButtons = radiobuttonGroups.add();
						with (sizeButtons) {
							radiobuttonControls.add({staticLabel:"A4 en hauteur", checkedState:aSiz});
							radiobuttonControls.add({staticLabel:"A4 en largeur", checkedState:bSiz});
							radiobuttonControls.add({staticLabel:"A3 en hauteur", checkedState:cSiz});
							radiobuttonControls.add({staticLabel:"A3 en largeur", checkedState:dSiz});
							radiobuttonControls.add({staticLabel:"dfinition utilisateur...", minWidth:textWidth, checkedState:eSiz});
						}
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"... largeur et hauteur", minWidth:labelWidth});
							var pageSizeField = textEditboxes.add({editContents:pSiz, minWidth:84});
							staticTexts.add({staticLabel:"mm"});
						}
					}
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Les marges", minWidth:labelWidth});
							var marginsField = textEditboxes.add({editContents:mVal, minWidth:84});
							staticTexts.add({staticLabel:"mm (y1 y2 x1 x2)"});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Nombre de ranges", minWidth:labelWidth});
					var nRowsField = integerEditboxes.add({editValue:rVal, minWidth:36});
					staticTexts.add({staticLabel:"Distance Y", minWidth:labelWidth2});
					var verticalOffsetField = realEditboxes.add({editValue:vOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Nombre de colonnes", minWidth:labelWidth});
					var nColumnsField = integerEditboxes.add({editValue:cVal, minWidth:36});
					staticTexts.add({staticLabel:"Distance X", minWidth:labelWidth2});
					var horizontalOffsetField = realEditboxes.add({editValue:hOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Disposition", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var creButtons = radiobuttonGroups.add();
						with (creButtons) {
							radiobuttonControls.add({staticLabel:"de gauche  droite", checkedState:aDir, minWidth:205});
							radiobuttonControls.add({staticLabel:"du haut vers le bas", checkedState:bDir});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Trier", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var sorButtons = radiobuttonGroups.add();
						with (sorButtons) {
							radiobuttonControls.add({staticLabel:"alphabtiquement", checkedState:aSor, minWidth:206});
							radiobuttonControls.add({staticLabel:"numriquement", checkedState:bSor});
							radiobuttonControls.add({staticLabel:"selon la date de cration", checkedState:cSor});
						}
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Direction", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var dirButtons = radiobuttonGroups.add();
						with (dirButtons) {
							radiobuttonControls.add({staticLabel:"ascendante", checkedState:dSor});
							radiobuttonControls.add({staticLabel:"descendante", checkedState:eSor});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Adapter les images", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var fitButtons = radiobuttonGroups.add();
						with (fitButtons) {
							radiobuttonControls.add({staticLabel:"proportionnellement", checkedState:fPrp, minWidth:206});
							radiobuttonControls.add({staticLabel:"au % le plus petit", checkedState:sPct});
							radiobuttonControls.add({staticLabel:"laisser  100%", checkedState:hPct});
							radiobuttonControls.add({staticLabel:"le bloc au contenu", minWidth:textWidth, checkedState:fFra});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"La lgende", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var labelsButtons = radiobuttonGroups.add();
						with (labelsButtons) {
							radiobuttonControls.add({staticLabel:"aucune", checkedState:nNam});
							radiobuttonControls.add({staticLabel:"le nom du fichier", checkedState:fNam});
							radiobuttonControls.add({staticLabel:"le chemin entier", checkedState:pNam});
						}
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Les informations", minWidth:labelWidth});
					with (dialogColumns.add()) {
						var sizeInfo = checkboxControls.add({staticLabel:"largeur x hauteur (original)", checkedState:sInf, minWidth:206});
						var ppiInfo  = checkboxControls.add({staticLabel:"ppi (exkl. \".eps\", \".pdf\", \".ai\")", checkedState:pInf});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le corps", minWidth:labelWidth});
					var typeSize = realEditboxes.add({editValue:tSiz, minWidth:36});
					staticTexts.add({staticLabel:"pt  "});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"La justification", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var justButtons = radiobuttonGroups.add();
						with (justButtons) {
							radiobuttonControls.add({staticLabel:" gauche", checkedState:jLft});
							radiobuttonControls.add({staticLabel:"centre", checkedState:jCnt});
							radiobuttonControls.add({staticLabel:" droite", checkedState:jRgt});
						}
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" ", minWidth:labelWidth+10});
			var removeEmptyFramesCheckbox = checkboxControls.add({staticLabel:"supprimer les blocs vides", checkedState:rEmp});
		}
	}
	// afficher le dialogue et convertir les entres
	var dResult = aDialog.show();
	if (dResult == true) {
		// le dossier principal ou galement les sous-dossiers
		var folLabel = folButtons.selectedButton;
		var folBtn = folLabel;
		if (folBtn == 0) {
			fMan = true;
			fSub = false;
		}
		else if (folBtn == 1) {
			fMan = false;
			fSub = true;
		}
		// le format de page
		tmpSiz = pageSizeField.editContents;
		var sizeType = sizeButtons.selectedButton;
		var sBtn = sizeType;
		aSiz = bSiz = cSiz = dSiz = eSiz = false;
		if (sBtn == 0) {
			aSiz = true;
			pW = 210;
			pH = 297;
		}
		else if (sBtn == 1) {
			bSiz = true;
			pW = 297;
			pH = 210;
		}
		else if (sBtn == 2) {
			cSiz = true;
			pW = 297;
			pH = 420;
		}
		else if (sBtn == 3) {
			dSiz = true;
			pW = 420;
			pH = 297;
		}
		else if (sBtn == 4) {
			eSiz = true;
			var tmpSize = tmpSiz.split(" ");
			if (tmpSize.length != 2) {
				alert ("Il faut entrer deux valeurs dans le champ largeur et hauteur.", "", true);
				pSiz = tmpSiz;
				aDialog.destroy();
				exit();
			}
			pW = tmpSize[0]*1;
			if (isNaN(pW)) {
				alert ("Largeur de la page: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
			pH = tmpSize[1]*1;
			if (isNaN(pH)) {
				alert ("Hauteur de la page: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
		}
		pSiz = tmpSiz;
		// les marges
		mVal = marginsField.editContents;
		var mVals = mVal.split(" ");
		if (mVals.length == 1) {
			var oneVal = mVal*1;
			if (isNaN(oneVal)) {
				alert ("Les marges: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
			marY1 = marY2 = marX1 = marX2 = oneVal;
		}
		else if (mVals.length == 4) {
			marY1 = mVals[0]*1;
			if (isNaN(marY1)) {
				alert ("Marge en haut: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
			marY2 = mVals[1]*1;
			if (isNaN(marY2)) {
				alert ("Marge en bas: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
			marX1 = mVals[2]*1;
			if (isNaN(marX1)) {
				alert ("Marge gauche: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
			marX2 = mVals[3]*1;
			if (isNaN(marX2)) {
				alert ("Marge droit: valeur invalide.", "", true);
				aDialog.destroy();
				exit();
			}
		}
		else {
			alert ("Entrer quatre valeurs (ou une seule) au champ des marges.", "", true);
			aDialog.destroy();
			exit();
		}
		var nRows = nRowsField.editValue;
		rVal = nRows;
		var nColumns = nColumnsField.editValue;
		cVal = nColumns;
		var verticalOffset = verticalOffsetField.editValue;
		vOff = verticalOffset;
		var horizontalOffset = horizontalOffsetField.editValue;
		hOff = horizontalOffset;
		// die Anordnung
		var creType = creButtons.selectedButton;
		var crBtn = creType;
		aDir = bDir = false;
		if (crBtn == 0) {
			aDir = true;
		}
		else if (crBtn == 1) {
			bDir = true;
		}
		// le tri
		var sortType = sorButtons.selectedButton;
		var soBtn = sortType;
		aSor = bSor = cSor = false;
		if (soBtn == 0) {
			aSor = true;
		}
		else if (soBtn == 1) {
			bSor = true;
		}
		else if (soBtn == 2) {
			cSor = true;
		}
		var dirType = dirButtons.selectedButton;
		var diBtn = dirType;
		dSor = eSor = false;
		if (diBtn == 0) {
			dSor = true;
		}
		else if (diBtn == 1) {
			eSor = true;
		}
		// Bilder anpassen
		var fitType = fitButtons.selectedButton;
		var fBtn = fitType;
		fPrp = sPct = hPct = fFra = false;
		if (fBtn == 0) {
			fPrp = true;
		}
		else if (fBtn == 1) {
			sPct = true;
		}
		else if (fBtn == 2) {
			hPct = true;
		}
		else if (fBtn == 3) {
			fFra = true;
		}
		// la lgende
		var selLabel = labelsButtons.selectedButton;
		rBtn = selLabel;
		nNam = fNam = pNam = false;
		if (rBtn == 0) {
			nNam = true;
		}
		else if (rBtn == 1) {
			fNam = true;
		}
		else if (rBtn == 2) {
			pNam = true;
		}
		// les informations
		sInf = sizeInfo.checkedState;
		pInf= ppiInfo.checkedState;
		// le corps
		tSiz = typeSize.editValue;
		// la justification
		var justType = justButtons.selectedButton;
		var jBtn = justType;
		jLft = jCnt = jRgt = false;
		if (jBtn == 0) {
			jLft = true;
			txtJust = Justification.leftAlign;
		}
		else if (jBtn == 1) {
			jCnt = true;
			txtJust = Justification.centerAlign;
		}
		else if (jBtn == 2) {
			jRgt = true;
			txtJust = Justification.rightAlign;
		}
		// supprimer des blocs vides
		var removeEmptyFrames = removeEmptyFramesCheckbox.checkedState;
		rEmp = removeEmptyFrames;
		aDialog.destroy();
		
		// la liste des prfrences...
		var prefsList = new Array(fMan,fSub,aSiz,bSiz,cSiz,dSiz,eSiz,pSiz,mVal,rVal,cVal,vOff,hOff,aDir,bDir,aSor,bSor,cSor,dSor,eSor,fPrp,sPct,hPct,fFra,nNam,fNam,pNam,sInf,pInf,tSiz,jLft,jCnt,jRgt,rEmp);
		// ... la convertir en chane de texte ...
		var curDef = prefsList.join("\n");
		// ... et l'envoyer  la fonction qui l'crit dans un fichier
		writeResult(curDef);
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// lister les noms
function getNames(tmpList) {
	namesArr = new Array();
	for (var n=0; n<tmpList.length; n++) {
		var curName = tmpList[n].name;
		namesArr.push([tmpList[n], curName]);
	}
	return namesArr;
}

// extraire les dates de cration
function getDates(tmpList) {
	// crer un document temporaire et un bloc image
	var tmpDoc = app.documents.add(false);
	var tmpFrm = tmpDoc.rectangles.add();
	datesArr = new Array();

	for (var n=0; n<tmpList.length; n++) {
		// importer l'image actuelle 
		var curImage = tmpList[n];
		tmpFrm.place(curImage);
		// mmoriser la date de cration
		try {
			var curTime = (tmpDoc.links[0].linkXmp.creationDate).getTime();
		}
		catch (e) {
			var curTime = (tmpList[n].created).getTime();
		}
		datesArr.push([tmpList[n], curTime]);
	}
	// fermer le document temporaire 
	tmpDoc.close(SaveOptions.no);
	return datesArr;
}

// extraire les chiffres, crer une nouvelle liste
function getNumbers(tmpList, nNames, num) {
	numbersArr = new Array();
	for (var n=0; n<nNames; n++) {
		var numVal = tmpList[n].name.match(num);
		numbersArr.push([tmpList[n], numVal]);
	}
	return numbersArr;
}

// crire le rsultat dans un fichier
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/cat210.txt");
	}
	else {
		var f = File("~/Library/Preferences/cat210.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// la fonction qui cre le document et les blocs, 
// puis importe les images et place les lgendes
function makeImageCatalog(){
	var curPage, curFile, x1, y1, x2, y2, curRect, labelStyle, labelLayer;
	var framesPerPage = rVal * cVal;
	var marginPrefs = app.marginPreferences;
	var oldY1 = marginPrefs.top;
	var oldX1 = marginPrefs.left;
	var oldY2 = marginPrefs.bottom;
	var oldX2 = marginPrefs.right;
	marginPrefs.top = marY1;
	marginPrefs.left = marX1;
	marginPrefs.bottom = marY2;
	marginPrefs.right = marX2;
	var curDoc = app.documents.add();
	app.marginPreferences.top = oldY1;
	app.marginPreferences.left = oldX1;
	app.marginPreferences.bottom = oldY2;
	app.marginPreferences.right = oldX2;
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	var docPrefs = curDoc.documentPreferences;
	var nFrames = defList.length;
	var nPages = Math.round(nFrames / framesPerPage);
	if ((nPages*framesPerPage) < nFrames) {
		nPages++;
	}
	docPrefs.pageWidth = pW;
	docPrefs.pageHeight = pH;
	docPrefs.pagesPerDocument = nPages;
	docPrefs.facingPages = false;
	var liveWidth = (pW - ((marX1) + (marX2))) + hOff;
	var liveHeight = pH - ((marY1) + (marY2));
	var columnWidth = liveWidth / cVal;
	var frameWidth = columnWidth - hOff;
	var rowHeight = (liveHeight / rVal);
	var frameHeight = rowHeight - vOff;
	var allPages = curDoc.pages;
	if (rBtn > 0){
		// crer la feuille de style de paragraphe "legende"
		labelStyle = curDoc.paragraphStyles.item("Bildlegende");
		try {
			labelStyle.name;
		}
		catch (e) {
			labelStyle = curDoc.paragraphStyles.add({name:"Bildlegende"});
		}
		labelStyle.pointSize = tSiz;
		labelStyle.justification = txtJust;
		// crer le calque "legendes"
		var labelLayer = curDoc.layers.item("legendes");
		try {
			labelLayer.name;
		}
		catch (e){
			labelLayer = curDoc.layers.add({name:"legendes"});
		}
	}
	// crer les blocs dans le sens inverse
	var curPage;
	var noColor = curDoc.swatches.itemByName("None");
	for (p = curDoc.pages.length-1; p>=0; p--) {
		curPage = allPages.item(p); 
		if (aDir == true) {
			for (var j=rVal; j>=1; j--) {
				y1 = marY1+(rowHeight*(j-1));
				y2 = y1+frameHeight;
				for (var k=cVal; k>=1; k--) {
					x1 = marX1+(columnWidth*(k-1));
					x2 = x1+frameWidth;
					curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], strokeWeight:0, strokeColor:noColor});
				}
			}
		}
		else {
			for (var k=cVal; k>=1; k--) {
				x1 = marX1+(columnWidth*(k-1));
				x2 = x1+frameWidth;
				for (var j=rVal; j>=1; j--) {
					y1 = marY1+(rowHeight*(j-1));
					y2 = y1+frameHeight;
					curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], strokeWeight:0, strokeColor:noColor});
				}
			}
		}
	}
	
	// l'importation des images peut tre faite dans l'ordre ascendant
	// puisque le blocs ont t cres inversement
	var cS, rawW, rawH, imgW, imgH, curSize, curRes;
	var oldPc, newPc, pathItems, labelString, curName, curItems, curSuf;
	for (i = 0; i < nFrames; i++) {
		curFile = defList[i][0];
		curRect = curDoc.rectangles.item(i);
		try {
			curRect.place(File(curFile));
			cS = curRect.allGraphics[0].geometricBounds;
			rawW = cS[3]-cS[1];
			rawH = cS[2]-cS[0];
			imgW = (Math.floor(((rawW * 1000) + 0.5)))/1000;
			imgH = (Math.floor(((rawH * 1000) + 0.5)))/1000;
			curSize = imgW + " x " + imgH + " mm";
			actRes = -1;
			try {
				var actRes = curRect.allGraphics[0].actualPpi[0];
			}
			catch (e) {
			}
			var curPath = curFile.fsName.toString();
			if (curPath.indexOf("\u0300") != -1) {
				curPath = rep1(curPath);
			}
			if (curPath.indexOf("\u0301") != -1) {
				curPath = rep2(curPath);
			}
			if (curPath.indexOf("\u0302") != -1) {
				curPath = rep3(curPath);
			}
			if (curPath.indexOf("\u0303") != -1) {
				curPath = rep4(curPath);
			}
			if (curPath.indexOf("\u0308") != -1) {
				curPath = rep5(curPath);
			}
			if (curPath.indexOf("\u030A") != -1) {
				curPath = rep6(curPath);
			}
			if (curPath.indexOf("\u0327") != -1) {
				curPath = rep7(curPath);
			}
			curRect.label = curPath;
			// appliquer les optionen d'adaptations
			if (fPrp) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			if (sPct) {
				// adapter le contenu proportionnellement
				curRect.fit(FitOptions.FILL_PROPORTIONALLY);
				// mmoriser le pourcentage
				oldPc = curRect.allGraphics[0].horizontalScale;
				// arrondir la valeur  une position dcimale
				newPc = Math.ceil((oldPc + 0.5)*10) / 10;
				// appliquer la nouvelle valeur
				curRect.allGraphics[0].properties = {horizontalScale:newPc, verticalScale:newPc};
				// centrer l'image
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			if (fFra) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.FRAME_TO_CONTENT);
			}
			effRes = -1;
			try {
				var effRes = curRect.allGraphics[0].effectivePpi[0];
			}
			catch (e) {
			}
			// insrer la lgende (si dsir)
			if (rBtn > 0) {
				x1 = curRect.geometricBounds[1];
				y1 = curRect.geometricBounds[2];
				x2 = curRect.geometricBounds[3];
				y2 = curRect.geometricBounds[2]+vOff;
				if (rBtn == 1) {
					pathItems = curPath.split("/");
					labelString = pathItems[(pathItems.length)-1];
					curName = labelString.toLowerCase();
					try {
						curItems = curName.split(".");
						curSuf = curItems[(curItems.length)-1];
						if (actRes != -1) {
							if (sInf && pInf) {
								labelString = labelString + "\n" + curSize + "\noriginal: " + actRes + " ppi / effectif: " + effRes + " ppi";
							}
							else if (sInf) {
								labelString = labelString + "\n" + curSize;
							}
							else if (pInf) {
								labelString = labelString + "\noriginal: " + actRes + " ppi / effectif: " + effRes + " ppi";
							}
						}
						else {
							if (sInf) {
								labelString = labelString + "\n" + curSize;
							}
						}
					}
					catch (e) {
					}
				}
				else if (rBtn == 2) {
					labelString = curPath;
				}
				textFrame = curRect.parent.textFrames.add(labelLayer, undefined, undefined,{geometricBounds:[y1, x1, y2, x2], contents:labelString});
				textFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset;
				textFrame.texts[0].appliedParagraphStyle = labelStyle;
			}
		}
		catch (e) {
		}
	}
	// supprimer des blocs vides, si c'est souhait
	if (rEmp == 1) {
		for (var i = curDoc.rectangles.length-1; i >= 0; i--) {
			if (curDoc.rectangles.item(i).contentType == ContentType.unassigned) {
				curDoc.rectangles.item(i).remove();
			}
			else {
				// quitter la boucle ds qu'un bloc vide est trouv
				break;
			}
		}
	}
}

// les fonctions qui convertissent les caractres accentus en un seul signe
function rep1(curPath) {
	curPath = curPath.replace(/a\u0300/g, '').replace(/A\u0300/g, '');
	curPath = curPath.replace(/e\u0300/g, '').replace(/E\u0300/g, '');
	curPath = curPath.replace(/i\u0300/g, '').replace(/I\u0300/g, '');
	curPath = curPath.replace(/o\u0300/g, '').replace(/O\u0300/g, '');
	curPath = curPath.replace(/u\u0300/g, '').replace(/U\u0300/g, '');
	return curPath;
}

function rep2(curPath) {
	curPath = curPath.replace(/a\u0301/g, '').replace(/A\u0301/g, '');
	curPath = curPath.replace(/e\u0301/g, '').replace(/E\u0301/g, '');
	curPath = curPath.replace(/i\u0301/g, '').replace(/I\u0301/g, '');
	curPath = curPath.replace(/o\u0301/g, '').replace(/O\u0301/g, '');
	curPath = curPath.replace(/u\u0301/g, '').replace(/U\u0301/g, '');
	return curPath;
}

function rep3(curPath) {
	curPath = curPath.replace(/a\u0302/g, '').replace(/A\u0302/g, '');
	curPath = curPath.replace(/e\u0302/g, '').replace(/E\u0302/g, '');
	curPath = curPath.replace(/i\u0302/g, '').replace(/I\u0302/g, '');
	curPath = curPath.replace(/o\u0302/g, '').replace(/O\u0302/g, '');
	curPath = curPath.replace(/u\u0302/g, '').replace(/U\u0302/g, '');
	return curPath;
}

function rep4(curPath) {
	curPath = curPath.replace(/a\u0303/g, '').replace(/A\u0303/g, '');
	curPath = curPath.replace(/n\u0303/g, '').replace(/N\u0303/g, '');
	curPath = curPath.replace(/o\u0303/g, '').replace(/O\u0303/g, '');
	return curPath;
}

function rep5(curPath) {
	curPath = curPath.replace(/a\u0308/g, '').replace(/A\u0308/g, '');
	curPath = curPath.replace(/e\u0308/g, '').replace(/E\u0308/g, '');
	curPath = curPath.replace(/i\u0308/g, '').replace(/I\u0308/g, '');
	curPath = curPath.replace(/o\u0308/g, '').replace(/O\u0308/g, '');
	curPath = curPath.replace(/u\u0308/g, '').replace(/U\u0308/g, '');
	curPath = curPath.replace(/y\u0308/g, '').replace(/Y\u0308/g, '');
	return curPath;
}

function rep6(curPath) {
	curPath = curPath.replace(/a\u030A/g, '').replace(/A\u030A/g, '');
	return curPath;
}

function rep7(curPath) {
	curPath = curPath.replace(/c\u0327/g, '').replace(/C\u0327/g, '');
	return curPath;
}